;;; ralee-faces.el

; Copyright (c) 2004 Sam Griffiths-Jones
;
; This is part of RALEE -- see
; http://www.sanger.ac.uk/Users/sgj/ralee/ and the 00README file
; that should accompany this file.
;
; RALEE is free software; you can redistribute it and/or modify it
; under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; RALEE is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with RALEE; if not, write to the Free Software Foundation,
; Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA



; complex definition of a face
; try a simpler one
(defface ralee-face-a
  `((((type tty) (class color))
     (:background "skyblue" :foreground "black"))
    (((type tty) (class mono))
     (:inverse-video t))
    (((class color) (background dark))
     (:background "skyblue" :foreground "black"))
    (((class color) (background light))
     (:background "skyblue" :foreground "black"))
    (t (:background "gray")))
  "Highlighting face a"
  :group 'basic-faces)

(defface ralee-face-b
  `((((type tty) (class color))
     (:background "lightgreen" :foreground "black"))
    (((type tty) (class mono))
     (:inverse-video t))
    (((class color) (background dark))
     (:background "lightgreen" :foreground "black"))
    (((class color) (background light))
     (:background "lightgreen" :foreground "black"))
    (t (:background "gray")))
  "Highlighting face b"
  :group 'basic-faces)

(defface ralee-face-c
  `((((type tty) (class color))
     (:background "pink" :foreground "black"))
    (((type tty) (class mono))
     (:inverse-video t))
    (((class color) (background dark))
     (:background "pink" :foreground "black"))
    (((class color) (background light))
     (:background "pink" :foreground "black"))
    (t (:background "gray")))
  "Highlighting face c"
  :group 'basic-faces)

(defface ralee-face-d
  `((((type tty) (class color))
     (:background "yellow" :foreground "black"))
    (((type tty) (class mono))
     (:inverse-video t))
    (((class color) (background dark))
     (:background "yellow" :foreground "black"))
    (((class color) (background light))
     (:background "yellow" :foreground "black"))
    (t (:background "gray")))
  "Highlighting face d"
  :group 'basic-faces)

(defface ralee-face-e
  `((((type tty) (class color))
     (:background "violet" :foreground "black"))
    (((type tty) (class mono))
     (:inverse-video t))
    (((class color) (background dark))
     (:background "violet" :foreground "black"))
    (((class color) (background light))
     (:background "violet" :foreground "black"))
    (t (:background "gray")))
  "Highlighting face e"
  :group 'basic-faces)

(defface ralee-face-f
  `((((type tty) (class color))
     (:background "gold" :foreground "black"))
    (((type tty) (class mono))
     (:inverse-video t))
    (((class color) (background dark))
     (:background "gold" :foreground "black"))
    (((class color) (background light))
     (:background "gold" :foreground "black"))
    (t (:background "gray")))
  "Highlighting face f"
  :group 'basic-faces)

(defface ralee-face-g
  `((((type tty) (class color))
     (:background "wheat" :foreground "black"))
    (((type tty) (class mono))
     (:inverse-video t))
    (((class color) (background dark))
     (:background "wheat" :foreground "black"))
    (((class color) (background light))
     (:background "wheat" :foreground "black"))
    (t (:background "gray")))
  "Highlighting face g"
  :group 'basic-faces)

(defface ralee-face-h
  `((((type tty) (class color))
     (:background "cyan" :foreground "black"))
    (((type tty) (class mono))
     (:inverse-video t))
    (((class color) (background dark))
     (:background "cyan" :foreground "black"))
    (((class color) (background light))
     (:background "cyan" :foreground "black"))
    (t (:background "gray")))
  "Highlighting face h"
  :group 'basic-faces)

(defface ralee-face-i
  `((((type tty) (class color))
     (:background "gray" :foreground "black"))
    (((type tty) (class mono))
     (:inverse-video t))
    (((class color) (background dark))
     (:background "gray" :foreground "black"))
    (((class color) (background light))
     (:background "gray" :foreground "black"))
    (t (:background "gray")))
  "Highlighting face i"
  :group 'basic-faces)


(copy-face 'ralee-face-a 'ralee-face-a-bold)
(copy-face 'ralee-face-b 'ralee-face-b-bold)
(copy-face 'ralee-face-c 'ralee-face-c-bold)
(copy-face 'ralee-face-d 'ralee-face-d-bold)
(copy-face 'ralee-face-e 'ralee-face-e-bold)
(copy-face 'ralee-face-f 'ralee-face-f-bold)
(copy-face 'ralee-face-g 'ralee-face-g-bold)
(copy-face 'ralee-face-h 'ralee-face-h-bold)
(copy-face 'ralee-face-i 'ralee-face-i-bold)

(if (featurep 'xemacs)
    (progn
      (set-face-property 'ralee-face-a-bold 'highlight nil)
      (set-face-property 'ralee-face-b-bold 'highlight nil)
      (set-face-property 'ralee-face-c-bold 'highlight nil)
      (set-face-property 'ralee-face-d-bold 'highlight nil)
      (set-face-property 'ralee-face-e-bold 'highlight nil)
      (set-face-property 'ralee-face-f-bold 'highlight nil)
      (set-face-property 'ralee-face-g-bold 'highlight nil)
      (set-face-property 'ralee-face-h-bold 'highlight nil)
      (set-face-property 'ralee-face-i-bold 'highlight nil)
      )

  (set-face-attribute 'ralee-face-a-bold nil :bold "true")
  (set-face-attribute 'ralee-face-b-bold nil :bold "true")
  (set-face-attribute 'ralee-face-c-bold nil :bold "true")
  (set-face-attribute 'ralee-face-d-bold nil :bold "true")
  (set-face-attribute 'ralee-face-e-bold nil :bold "true")
  (set-face-attribute 'ralee-face-f-bold nil :bold "true")
  (set-face-attribute 'ralee-face-g-bold nil :bold "true")
  (set-face-attribute 'ralee-face-h-bold nil :bold "true")
  (set-face-attribute 'ralee-face-i-bold nil :bold "true")
  )


(setq ralee-faces '(ralee-face-a 
		    ralee-face-b 
		    ralee-face-c
		    ralee-face-d
		    ralee-face-e
		    ralee-face-f
		    ralee-face-g
		    ralee-face-h
		    ralee-face-i
		    ))

;; for highlight-current-line method
;; should merge this into ralee-faces hash above
(setq ralee-bold-faces (list
			(cons 'ralee-face-a 'ralee-face-a-bold)
			(cons 'ralee-face-b 'ralee-face-b-bold)
			(cons 'ralee-face-c 'ralee-face-c-bold)
			(cons 'ralee-face-d 'ralee-face-d-bold)
			(cons 'ralee-face-e 'ralee-face-e-bold)
			(cons 'ralee-face-f 'ralee-face-f-bold)
			(cons 'ralee-face-g 'ralee-face-g-bold)
			(cons 'ralee-face-h 'ralee-face-h-bold)
			(cons 'ralee-face-i 'ralee-face-i-bold)
		       ))

;; for the postscript writing stuff
(setq ralee-face-colours (list
			  (cons 'ralee-face-a "0.53 0.81 0.92")
			  (cons 'ralee-face-b "0.57 0.93 0.57")
			  (cons 'ralee-face-c "1 0.75 0.8")
			  (cons 'ralee-face-d "1 1 0")
			  (cons 'ralee-face-e "0.93 0.51 0.93")
			  (cons 'ralee-face-f "1 0.84 0")
			  (cons 'ralee-face-g "0.96 0.87 0.70")
			  (cons 'ralee-face-h "0 1 1")
			  (cons 'ralee-face-i "0.66 0.66 0.66")
			  ))


(provide 'ralee-faces)


